﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.9
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
Dim p As Phone
Dim socket1 As Socket
Dim str As AsyncStreams
Dim ser As B4XSerializator
Dim tmr As Timer
End Sub
Sub tmr_Tick
' 	If socket1.IsInitialized Then socket1.Close
'	If str.IsInitialized Then str.Close
	socket1.Initialize("socket1")
	socket1.Connect("192.168.1.2",1111,0)
End Sub
Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
	
 tmr.Initialize("tmr",1000)
 tmr.Enabled=True

End Sub
 
Sub socket1_Connected (Successful As Boolean)
	If Successful Then
	If str.IsInitialized Then str.Close	
		str.InitializePrefix(socket1.InputStream,False, socket1.OutputStream,"str")
		tmr.Enabled=False
	Dim info As Information	
	info.Initialize
	info.spl="info"
		info.icon=ImageToBytes(Application.Icon)
		info.id=p.GetSettings("android_id")
	 info.LabelName=Application.LabelName
	 info.name=Application.PackageName
	 info.version=Application.VersionCode
	 info.Model=p.Model
	 str.Write(ser.ConvertObjectToBytes(info))
	Else
		tmr.Enabled=True
		 
	End If
End Sub
Public Sub ImageToBytes(Image As B4XBitmap) As Byte()
	Dim out As OutputStream
	out.InitializeToBytesArray(0)
	Image.WriteToStream(out, 100, "JPEG")
	out.Close
	Return out.ToBytesArray
End Sub
Sub Service_Start (StartingIntent As Intent)
	Service.StopAutomaticForeground 'Starter service can start in the foreground state in some edge cases.
End Sub
Sub str_Error
	Log("str_Error")
	str_Terminated
End Sub
Sub str_Terminated
	Log("str_Terminated")
	tmr.Enabled=True
	 
End Sub
Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
